/*
 * This file was generated by qdbusxml2cpp version 0.7
 * Command line was: qdbusxml2cpp -l Oscl::Qt::DBus::BlueZ::Mesh::Node1::Server -i ushortarray.h -i server.h -p proxy dbus.xml
 *
 * qdbusxml2cpp is Copyright (C) 2015 The Qt Company Ltd.
 *
 * This is an auto-generated file.
 * Do not edit! All changes made to it will be lost.
 */

#ifndef PROXY_H_1600719962
#define PROXY_H_1600719962

#include <QtCore/QObject>
#include <QtCore/QByteArray>
#include <QtCore/QList>
#include <QtCore/QMap>
#include <QtCore/QString>
#include <QtCore/QStringList>
#include <QtCore/QVariant>
#include <QtDBus/QtDBus>
#include "ushortarray.h"
#include "server.h"

/*
 * Proxy class for interface org.bluez.mesh.Node1
 */
class OrgBluezMeshNode1Interface: public QDBusAbstractInterface
{
    Q_OBJECT
public:
    static inline const char *staticInterfaceName()
    { return "org.bluez.mesh.Node1"; }

public:
    OrgBluezMeshNode1Interface(const QString &service, const QString &path, const QDBusConnection &connection, QObject *parent = 0);

    ~OrgBluezMeshNode1Interface();

    Q_PROPERTY(Oscl::Qt::DBus::BlueZ::Mesh::Node1::UshortArray Addresses READ addresses)
    inline Oscl::Qt::DBus::BlueZ::Mesh::Node1::UshortArray addresses() const
    { return qvariant_cast< Oscl::Qt::DBus::BlueZ::Mesh::Node1::UshortArray >(property("Addresses")); }

    Q_PROPERTY(bool Beacon READ beacon)
    inline bool beacon() const
    { return qvariant_cast< bool >(property("Beacon")); }

    Q_PROPERTY(QVariantMap Features READ features)
    inline QVariantMap features() const
    { return qvariant_cast< QVariantMap >(property("Features")); }

    Q_PROPERTY(uint IvIndex READ ivIndex)
    inline uint ivIndex() const
    { return qvariant_cast< uint >(property("IvIndex")); }

    Q_PROPERTY(bool IvUpdate READ ivUpdate)
    inline bool ivUpdate() const
    { return qvariant_cast< bool >(property("IvUpdate")); }

    Q_PROPERTY(uint SecondsSinceLastHeard READ secondsSinceLastHeard)
    inline uint secondsSinceLastHeard() const
    { return qvariant_cast< uint >(property("SecondsSinceLastHeard")); }

    Q_PROPERTY(uint SequenceNumber READ sequenceNumber)
    inline uint sequenceNumber() const
    { return qvariant_cast< uint >(property("SequenceNumber")); }

public Q_SLOTS: // METHODS
    inline QDBusPendingReply<> AddAppKey(const QDBusObjectPath &element_path, ushort destination, ushort app_index, ushort net_index, bool update)
    {
        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(element_path) << QVariant::fromValue(destination) << QVariant::fromValue(app_index) << QVariant::fromValue(net_index) << QVariant::fromValue(update);
        return asyncCallWithArgumentList(QLatin1String("AddAppKey"), argumentList);
    }

    inline QDBusPendingReply<> AddNetKey(const QDBusObjectPath &element_path, ushort destination, ushort subnet_index, ushort net_index, bool update)
    {
        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(element_path) << QVariant::fromValue(destination) << QVariant::fromValue(subnet_index) << QVariant::fromValue(net_index) << QVariant::fromValue(update);
        return asyncCallWithArgumentList(QLatin1String("AddNetKey"), argumentList);
    }

    inline QDBusPendingReply<> DevKeySend(const QDBusObjectPath &element_path, ushort destination, bool remote, ushort net_index, const QVariantMap &options, const QByteArray &data)
    {
        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(element_path) << QVariant::fromValue(destination) << QVariant::fromValue(remote) << QVariant::fromValue(net_index) << QVariant::fromValue(options) << QVariant::fromValue(data);
        return asyncCallWithArgumentList(QLatin1String("DevKeySend"), argumentList);
    }

    inline QDBusPendingReply<> Publish(const QDBusObjectPath &element_path, ushort model, const QVariantMap &options, const QByteArray &data)
    {
        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(element_path) << QVariant::fromValue(model) << QVariant::fromValue(options) << QVariant::fromValue(data);
        return asyncCallWithArgumentList(QLatin1String("Publish"), argumentList);
    }

    inline QDBusPendingReply<> Send(const QDBusObjectPath &element_path, ushort destination, ushort key_index, const QVariantMap &options, const QByteArray &data)
    {
        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(element_path) << QVariant::fromValue(destination) << QVariant::fromValue(key_index) << QVariant::fromValue(options) << QVariant::fromValue(data);
        return asyncCallWithArgumentList(QLatin1String("Send"), argumentList);
    }

Q_SIGNALS: // SIGNALS
};

namespace org {
  namespace bluez {
    namespace mesh {
      typedef ::OrgBluezMeshNode1Interface Node1;
    }
  }
}
#endif
